VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGSMTCSMP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 12/2022

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const API_TRUE As Long = &H1&
Private Const CC_STDCALL As Long = &H4&
Private Const GdiPlusVersion As Long = &H1&

Private Const IID_IGlobalSystemMediaTransportControlsSessionMediaProperties As String = "{68856cf6-adb4-54b2-ac16-05837907acb6}"

Private Const IID_IStream As String = "{0000000c-0000-0000-c000-000000000046}"
Private Const IID_IPicture As String = "{7bf80981-bf32-101a-8bbb-00aa00300cab}"
Private Const IID_IClosable As String = "{30d5a829-7fa4-4026-83bb-d75bae4ea99e}"
Private Const IID_IAsyncInfo As String = "{00000036-0000-0000-c000-000000000046}"
Private Const IID_IRandomAccessStream As String = "{905a0fe1-bc53-11df-8c49-001e4fc686da}"
Private Const IID_IContentTypeProvider As String = "{97d098a5-3b99-4de9-88a5-e11d2f50c795}"
Private Const IID_IRandomAccessStreamReference As String = "{33ee3134-1dd6-4e3a-8067-d1c162e8642b}"
Private Const IID_IRandomAccessStreamWithContentType As String = "{cc254827-4b3d-438f-9232-10c76bc7e038}"
Private Const IID_IReference_Enum_Windows_Media_MediaPlaybackType As String = "{e289f7d8-6ba7-50ab-9f13-6e4e51d15ca4}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IUnknown
    IUnknown_QueryInterface = 0
    IUnknown_Release = 2

    ' IInspectable
    IInspectable_GetIids = 3
    IInspectable_GetRuntimeClassName = 4
    IInspectable_GetTrustLevel = 5
    
    ' IAsyncInfo
    IAsyncInfo_GetStatus = 7
    IAsyncInfo_Close = 10

    ' IAsyncInterface
    IAsyncInterface_GetResults = 8
    
    ' IClosable
    IClosable_Close = 6
                        
    ' IGlobalSystemMediaTransportControlsSessionMediaProperties
    IGlobalSystemMediaTransportControlsSessionMediaProperties_GetTitle = 6
    IGlobalSystemMediaTransportControlsSessionMediaProperties_GetSubtitle = 7
    IGlobalSystemMediaTransportControlsSessionMediaProperties_GetAlbumArtist = 8
    IGlobalSystemMediaTransportControlsSessionMediaProperties_GetArtist = 9
    IGlobalSystemMediaTransportControlsSessionMediaProperties_GetAlbumTitle = 10
    IGlobalSystemMediaTransportControlsSessionMediaProperties_GetTrackNumber = 11
    IGlobalSystemMediaTransportControlsSessionMediaProperties_GetGenres = 12
    IGlobalSystemMediaTransportControlsSessionMediaProperties_GetAlbumTrackCount = 13
    IGlobalSystemMediaTransportControlsSessionMediaProperties_GetPlaybackType = 14
    IGlobalSystemMediaTransportControlsSessionMediaProperties_GetThumbnail = 15
                        
    ' IVectorView_HSTRING
    IVectorView_HSTRING_GetAt = 6
    IVectorView_HSTRING_GetSize = 7
                        
    ' IReference_Enum_Windows_Media_MediaPlaybackType
    IReference_Enum_Windows_Media_MediaPlaybackType_GetValue = 6

    ' IRandomAccessStreamReference
    IRandomAccessStreamReference_OpenReadAsync = 6
                        
    ' IContentTypeProvider
    IContentTypeProvider_GetContentType = 6
                        
End Enum

Private Enum AsyncStatus
    Started = 0
    Completed = 1
    Canceled = 2
    Error = 3
End Enum

Private Enum TrustLevel
    BaseTrust = 0
    PartialTrust = 1
    FullTrust = 2
End Enum

Private Enum Status
    OK = 0
    GenericError = 1
    InvalidParameter = 2
    OutOfMemory = 3
    ObjectBusy = 4
    InsufficientBuffer = 5
    NotImplemented = 6
    Win32Error = 7
    WrongState = 8
    Aborted = 9
    FileNotFound = 10
    ValueOverflow = 11
    AccessDenied = 12
    UnknownImageFormat = 13
    FontFamilyNotFound = 14
    FontStyleNotFound = 15
    NotTrueTypeFont = 16
    UnsupportedGdiplusVersion = 17
    GdiplusNotInitialized = 18
    PropertyNotFound = 19
    PropertyNotSupported = 20
    ProfileNotFound = 21
End Enum

Public Enum MediaPlaybackType
    MediaPlaybackType_Unknown = 0
    MediaPlaybackType_Music = 1
    MediaPlaybackType_Video = 2
    MediaPlaybackType_Image = 3
End Enum

' ----==== Types ====----
Private Type GUID
    data1 As Long
    data2 As Long
    data3 As Long
    data4 As Long
End Type

Private Type PictDesc
    cbSizeofStruct As Long
    picType As Long
    hImage As Long
    xExt As Long
    yExt As Long
End Type

Private Type GDIPlusStartupInput
    GdiPlusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

Private Type GdiplusStartupOutput
    NotificationHook As Long
    NotificationUnhook As Long
End Type

' ----==== Ole32.dll Declarations ====----
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long
                         
Private Declare Function StringFromGUID Lib "Ole32.dll" _
                         Alias "StringFromGUID2" ( _
                         ByRef rguid As GUID, _
                         ByVal lpsz As Long, _
                         ByVal cchMax As Long) As Long
                         
Private Declare Sub CoTaskMemFree Lib "Ole32.dll" ( _
                    ByVal hMem As Long)
                         
' ----==== Oleaut32.dll Declarations ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long

Private Declare Function OleCreatePictureIndirect Lib "Oleaut32.dll" ( _
                         ByRef lpPictDesc As PictDesc, _
                         ByRef riid As GUID, _
                         ByVal fOwn As Long, _
                         ByRef lplpvObj As Object) As Long

' ----==== Kernel32.dll Declarations ====----
Private Declare Sub CopyMemory Lib "Kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pTo As Any, _
                    ByRef uFrom As Any, _
                    ByVal lSize As Long)

Private Declare Function lstrlenW Lib "Kernel32.dll" ( _
                         ByVal lpString As Long) As Long

' ----==== Combase.dll Declarations ====----
Private Declare Function WindowsCreateString Lib "Combase.dll" ( _
                         ByVal sourceString As Long, _
                         ByVal lenght As Long, _
                         ByRef hString As Long) As Long

Private Declare Function WindowsGetStringRawBuffer Lib "Combase.dll" ( _
                         ByVal sourceString As Long, _
                         ByRef length As Long) As Long

Private Declare Function WindowsDeleteString Lib "Combase.dll" ( _
                         ByVal sourceString As Long) As Long

Private Declare Function RoGetActivationFactory Lib "Combase.dll" ( _
                         ByVal activatableClassId As Long, _
                         ByRef riid As GUID, _
                         ByRef factory As Long) As Long

Private Declare Function RoActivateInstance Lib "Combase.dll" ( _
                         ByVal activatableClassId As Long, _
                         ByRef instance As Long) As Long

' ----==== ShCore.dll Declarations ====----
Private Declare Function CreateStreamOverRandomAccessStream Lib "ShCore.dll" ( _
                         ByVal pRandomAccessStream As Long, _
                         ByRef riid As GUID, _
                         ByRef ppv As Long) As Long

' ----==== Gdiplus.dll Declarations ====----
Private Declare Function GdiplusShutdown Lib "GdiPlus.dll" ( _
                         ByVal token As Long) As Status
                         
Private Declare Function GdiplusStartup Lib "GdiPlus.dll" ( _
                         ByRef token As Long, _
                         ByRef lpInput As GDIPlusStartupInput, _
                         ByRef lpOutput As GdiplusStartupOutput) As Status

Private Declare Function GdipCreateHBITMAPFromBitmap Lib "GdiPlus.dll" ( _
                         ByVal bitmap As Long, _
                         ByRef hbmReturn As Long, _
                         ByVal background As Long) As Status

Private Declare Function GdipCreateBitmapFromHBITMAP Lib "GdiPlus.dll" ( _
                         ByVal hbm As Long, _
                         ByVal hpal As Long, _
                         ByRef bitmap As Long) As Status

Private Declare Function GdipDisposeImage Lib "GdiPlus.dll" ( _
                         ByVal image As Long) As Status

Private Declare Function GdipCreateBitmapFromStream Lib "GdiPlus.dll" ( _
                         ByVal mStream As Long, _
                         ByRef mBitmap As Long) As Status

' ----==== Variablen ====----
Private m_pIGlobalSystemMediaTransportControlsSessionMediaProperties As Long

' ----==== Class ====----
Private Sub Class_Initialize()
    '
End Sub

Private Sub Class_Terminate()
    Call Release(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties)
End Sub

' ----==== Properties ====----
Public Property Get IGlobalSystemMediaTransportControlsSessionMediaProperties() As Long
    IGlobalSystemMediaTransportControlsSessionMediaProperties = m_pIGlobalSystemMediaTransportControlsSessionMediaProperties
End Property

Public Property Let IGlobalSystemMediaTransportControlsSessionMediaProperties(ByVal pIGlobalSystemMediaTransportControlsSessionMediaProperties As Long)
    Call Release(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties)
    m_pIGlobalSystemMediaTransportControlsSessionMediaProperties = pIGlobalSystemMediaTransportControlsSessionMediaProperties
End Property

Public Property Get GetTitle() As String
    Dim Ret As String
    If m_pIGlobalSystemMediaTransportControlsSessionMediaProperties <> 0& Then
        Dim Value As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties, _
                  IGlobalSystemMediaTransportControlsSessionMediaProperties_GetTitle, _
                  VarPtr(Value)) = S_OK Then
            Ret = Ptr2Str(WindowsGetStringRawBuffer(Value, 0&))
        End If
    End If
    GetTitle = Ret
End Property

Public Property Get GetSubtitle() As String
    Dim Ret As String
    If m_pIGlobalSystemMediaTransportControlsSessionMediaProperties <> 0& Then
        Dim Value As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties, _
                  IGlobalSystemMediaTransportControlsSessionMediaProperties_GetSubtitle, _
                  VarPtr(Value)) = S_OK Then
            Ret = Ptr2Str(WindowsGetStringRawBuffer(Value, 0&))
        End If
    End If
    GetSubtitle = Ret
End Property

Public Property Get GetAlbumArtist() As String
    Dim Ret As String
    If m_pIGlobalSystemMediaTransportControlsSessionMediaProperties <> 0& Then
        Dim Value As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties, _
                  IGlobalSystemMediaTransportControlsSessionMediaProperties_GetAlbumArtist, _
                  VarPtr(Value)) = S_OK Then
            Ret = Ptr2Str(WindowsGetStringRawBuffer(Value, 0&))
        End If
    End If
    GetAlbumArtist = Ret
End Property

Public Property Get GetArtist() As String
    Dim Ret As String
    If m_pIGlobalSystemMediaTransportControlsSessionMediaProperties <> 0& Then
        Dim Value As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties, _
                  IGlobalSystemMediaTransportControlsSessionMediaProperties_GetArtist, _
                  VarPtr(Value)) = S_OK Then
            Ret = Ptr2Str(WindowsGetStringRawBuffer(Value, 0&))
        End If
    End If
    GetArtist = Ret
End Property

Public Property Get GetAlbumTitle() As String
    Dim Ret As String
    If m_pIGlobalSystemMediaTransportControlsSessionMediaProperties <> 0& Then
        Dim Value As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties, _
                  IGlobalSystemMediaTransportControlsSessionMediaProperties_GetAlbumTitle, _
                  VarPtr(Value)) = S_OK Then
            Ret = Ptr2Str(WindowsGetStringRawBuffer(Value, 0&))
        End If
    End If
    GetAlbumTitle = Ret
End Property

Public Property Get GetTrackNumber() As Long
    Dim Ret As Long
    If m_pIGlobalSystemMediaTransportControlsSessionMediaProperties <> 0& Then
        Dim Value As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties, _
                  IGlobalSystemMediaTransportControlsSessionMediaProperties_GetTrackNumber, _
                  VarPtr(Value)) = S_OK Then
            Ret = Value
        End If
    End If
    GetTrackNumber = Ret
End Property

Public Property Get GetGenresCount() As Long
    Dim Ret As Long
    If m_pIGlobalSystemMediaTransportControlsSessionMediaProperties <> 0& Then
        Dim pIVectorView_HSTRING As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties, _
                  IGlobalSystemMediaTransportControlsSessionMediaProperties_GetGenres, _
                  VarPtr(pIVectorView_HSTRING)) = S_OK Then
            Dim Value As Long
            If Invoke(pIVectorView_HSTRING, _
                      IVectorView_HSTRING_GetSize, _
                      VarPtr(Value)) = S_OK Then
                Ret = Value
            End If
            Call Release(pIVectorView_HSTRING)
        End If
    End If
    GetGenresCount = Ret
End Property

Public Property Get GetGenreByIndex(ByVal Index As Long) As String
    Dim Ret As String
    If m_pIGlobalSystemMediaTransportControlsSessionMediaProperties <> 0& Then
        If Index >= 0 And Index < Me.GetGenresCount Then
            Dim pIVectorView_HSTRING As Long
            If Invoke(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties, _
                      IGlobalSystemMediaTransportControlsSessionMediaProperties_GetGenres, _
                      VarPtr(pIVectorView_HSTRING)) = S_OK Then
                Dim Value As Long
                If Invoke(pIVectorView_HSTRING, _
                          IVectorView_HSTRING_GetAt, _
                          Index, VarPtr(Value)) = S_OK Then
                    Ret = Ptr2Str(WindowsGetStringRawBuffer(Value, 0&))
                End If
                Call Release(pIVectorView_HSTRING)
            End If
        End If
    End If
    GetGenreByIndex = Ret
End Property

Public Property Get GetGenres() As String()
    Dim Ret() As String
    If m_pIGlobalSystemMediaTransportControlsSessionMediaProperties <> 0& Then
        Dim pIVectorView_HSTRING As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties, _
                  IGlobalSystemMediaTransportControlsSessionMediaProperties_GetGenres, _
                  VarPtr(pIVectorView_HSTRING)) = S_OK Then
            Dim lngItems As Long
            If Invoke(pIVectorView_HSTRING, _
                      IVectorView_HSTRING_GetSize, _
                      VarPtr(lngItems)) = S_OK Then
                If lngItems < 0& Then
                    ReDim Ret(lngItems - 1)
                    Dim lngItem As Long
                    For lngItem = 0 To lngItems - 1
                        Dim Value As Long
                        If Invoke(pIVectorView_HSTRING, _
                                  IVectorView_HSTRING_GetAt, _
                                  lngItem, VarPtr(Value)) = S_OK Then
                            Ret(lngItem) = Ptr2Str(WindowsGetStringRawBuffer(Value, 0&))
                        End If
                    Next
                End If
            End If
            Call Release(pIVectorView_HSTRING)
        End If
    End If
    GetGenres = Ret
End Property

Public Property Get GetAlbumTrackCount() As Long
    Dim Ret As Long
    If m_pIGlobalSystemMediaTransportControlsSessionMediaProperties <> 0& Then
        Dim Value As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties, _
                  IGlobalSystemMediaTransportControlsSessionMediaProperties_GetAlbumTrackCount, _
                  VarPtr(Value)) = S_OK Then
            Ret = Value
        End If
    End If
    GetAlbumTrackCount = Ret
End Property

Public Property Get GetPlaybackType() As MediaPlaybackType
    Dim Ret As MediaPlaybackType
    If m_pIGlobalSystemMediaTransportControlsSessionMediaProperties <> 0& Then
        Dim pIReference_Enum_Windows_Media_MediaPlaybackType As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties, _
                  IGlobalSystemMediaTransportControlsSessionMediaProperties_GetPlaybackType, _
                  VarPtr(pIReference_Enum_Windows_Media_MediaPlaybackType)) = S_OK Then
            Dim Value As Long
            If Invoke(pIReference_Enum_Windows_Media_MediaPlaybackType, _
                      IReference_Enum_Windows_Media_MediaPlaybackType_GetValue, _
                      VarPtr(Value)) = S_OK Then
                Ret = Value
            End If
            Call Release(pIReference_Enum_Windows_Media_MediaPlaybackType)
        End If
    End If
    GetPlaybackType = Ret
End Property

Public Property Get GetPlaybackTypeAsString() As String
    Dim Ret As String
    Select Case Me.GetPlaybackType
    Case MediaPlaybackType.MediaPlaybackType_Unknown
        Ret = "Unknown"
    Case MediaPlaybackType.MediaPlaybackType_Music
        Ret = "Music"
    Case MediaPlaybackType.MediaPlaybackType_Video
        Ret = "Video"
    Case MediaPlaybackType.MediaPlaybackType_Image
        Ret = "Image"
    End Select
    GetPlaybackTypeAsString = Ret
End Property

Public Property Get GetThumbnail() As StdPicture
    Dim Ret As StdPicture
    If m_pIGlobalSystemMediaTransportControlsSessionMediaProperties <> 0& Then
        Dim pIRandomAccessStreamReference As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionMediaProperties, _
                  IGlobalSystemMediaTransportControlsSessionMediaProperties_GetThumbnail, _
                  VarPtr(pIRandomAccessStreamReference)) = S_OK Then
            Dim pIRandomAccessStreamWithContentType As Long
            If Invoke(pIRandomAccessStreamReference, _
                      IRandomAccessStreamReference_OpenReadAsync, _
                      VarPtr(pIRandomAccessStreamWithContentType)) = S_OK Then
                If WaitForAsync(pIRandomAccessStreamWithContentType) Then
                    Dim pIContentTypeProvider As Long
                    If Invoke(pIRandomAccessStreamWithContentType, _
                              IUnknown_QueryInterface, _
                              VarPtr(Str2Guid(IID_IContentTypeProvider)), _
                              VarPtr(pIContentTypeProvider)) = S_OK Then
                        Dim hContentType As Long
                        If Invoke(pIContentTypeProvider, _
                                  IContentTypeProvider_GetContentType, _
                                  VarPtr(hContentType)) = S_OK Then
                            If LCase$(Left$(Ptr2Str(WindowsGetStringRawBuffer(hContentType, 0&)), 5)) = "image" Then
                                Dim pIRandomAccessStream As Long
                                If Invoke(pIRandomAccessStreamWithContentType, _
                                          IUnknown_QueryInterface, _
                                          VarPtr(Str2Guid(IID_IRandomAccessStream)), _
                                          VarPtr(pIRandomAccessStream)) = S_OK Then
                                    Dim pIStream As Long
                                    If CreateStreamOverRandomAccessStream(pIRandomAccessStream, _
                                                                          Str2Guid(IID_IStream), _
                                                                          pIStream) = S_OK Then
                                        Set Ret = GetBitmapFromIStream(pIStream)
                                        Call Release(pIStream)
                                    End If
                                    Call Release(pIRandomAccessStream)
                                End If
                            End If
                        End If
                        Call Release(pIContentTypeProvider)
                    End If
                End If
                Call CloseAndRelease(pIRandomAccessStreamWithContentType)
            End If
            Call Release(pIRandomAccessStreamReference)
        End If
    End If
    Set GetThumbnail = Ret
End Property

' ----==== Subs & Functions ====----
Private Function GetBitmapFromIStream(ByVal pIStream As Long) As StdPicture
    Dim Ret As StdPicture
    If pIStream <> 0& Then
        Dim lngGdipToken As Long
        Dim tGdipStartupInput As GDIPlusStartupInput
        Dim tGdipStartupOutput As GdiplusStartupOutput
        tGdipStartupInput.GdiPlusVersion = GdiPlusVersion
        If GdiplusStartup(lngGdipToken, tGdipStartupInput, _
                          tGdipStartupOutput) = OK Then
            Dim pBitmap As Long
            If GdipCreateBitmapFromStream(pIStream, pBitmap) = OK Then
                Dim hBitmap As Long
                If GdipCreateHBITMAPFromBitmap(pBitmap, hBitmap, 0&) = OK Then
                    Dim tPictDesc As PictDesc
                    With tPictDesc
                        .cbSizeofStruct = Len(tPictDesc)
                        .picType = vbPicTypeBitmap
                        .hImage = hBitmap
                    End With
                    Dim oPicture As IPicture
                    If OleCreatePictureIndirect(tPictDesc, Str2Guid(IID_IPicture), _
                                                API_TRUE, oPicture) = S_OK Then
                        Set Ret = oPicture
                        Set oPicture = Nothing
                    End If
                End If
                Call GdipDisposeImage(pBitmap)
            End If
            If GdiplusShutdown(lngGdipToken) = OK Then lngGdipToken = 0&
        End If
    End If
    Set GetBitmapFromIStream = Ret
End Function

Private Function GetActivationFactory(ByVal ClassName As String, _
                                      ByVal IID As String, _
                                      ByRef pFactory As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    Dim hString As Long
    If WindowsCreateString(StrPtr(ClassName), Len(ClassName), hString) = S_OK Then
        If hString <> 0& Then
            If RoGetActivationFactory(hString, Str2Guid(IID), pFactory) = S_OK Then bolRet = True
            Call WindowsDeleteString(hString)
        End If
    End If
    GetActivationFactory = bolRet
End Function

Private Function GetActivateInstance(ByVal ClassName As String, _
                                     ByVal IID As String, _
                                     ByRef pInstance As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    Dim hString As Long
    If WindowsCreateString(StrPtr(ClassName), Len(ClassName), hString) = S_OK Then
        If hString <> 0& Then
            Dim pIInspectable As Long
            If RoActivateInstance(hString, pIInspectable) = S_OK Then
                If pIInspectable <> 0& Then
                    If Invoke(pIInspectable, IUnknown_QueryInterface, _
                              VarPtr(Str2Guid(IID)), VarPtr(pInstance)) = S_OK Then
                        If pInstance <> 0& Then bolRet = True
                    End If
                    Call Release(pIInspectable)
                End If
            End If
            Call WindowsDeleteString(hString)
        End If
    End If
    GetActivateInstance = bolRet
End Function

Private Function WaitForAsync(ByRef pInterface As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    If pInterface <> 0& Then
        Dim pIAsyncInfo As Long
        If Invoke(pInterface, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_IAsyncInfo)), _
                  VarPtr(pIAsyncInfo)) = S_OK Then
            Dim eStatus As AsyncStatus
            Do
                If Invoke(pIAsyncInfo, IAsyncInfo_GetStatus, _
                          VarPtr(eStatus)) = S_OK Then DoEvents
            Loop While eStatus = Started
            If eStatus = Completed Then
                bolRet = True
            Else
                Call Invoke(pIAsyncInfo, IAsyncInfo_Close)
            End If
            Call Release(pIAsyncInfo)
            If bolRet Then
                Dim pRet As Long
                If Invoke(pInterface, IAsyncInterface_GetResults, VarPtr(pRet)) = S_OK Then
                    Call Release(pInterface)
                    pInterface = pRet
                End If
            Else
                Call Release(pInterface)
            End If
        End If
    End If
    WaitForAsync = bolRet
End Function

Private Sub Release(ByRef pInterface As Long)
    Dim lngRet As Long
    If pInterface <> 0& Then
        Call Invoke(pInterface, IUnknown_Release)
        pInterface = 0&
    End If
End Sub

Private Function CloseAndRelease(ByRef pInterface As Long) As Long
    Dim lngRet As Long
    If pInterface <> 0& Then
        Dim pIClosable As Long
        If Invoke(pInterface, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_IClosable)), _
                  VarPtr(pIClosable)) = S_OK Then
            Call Invoke(pIClosable, IClosable_Close)
            Call Release(pIClosable)
            Call Release(pInterface)
            pInterface = 0&
        End If
    End If
    CloseAndRelease = lngRet
End Function

Private Sub GetInspectableInfo(ByVal pInspectableInterface As Long, _
                               ByVal strInterface As String)
    If pInspectableInterface <> 0& Then
        Debug.Print "Inspectable Info for: " & strInterface
        Debug.Print "RuntimeClassName = " & GetInspectable_GetRuntimeClassName(pInspectableInterface)
        Dim eTrustLevel As TrustLevel
        eTrustLevel = GetInspectable_GetTrustLevel(pInspectableInterface)
        Select Case eTrustLevel
            Case TrustLevel.BaseTrust
                Debug.Print "TrustLevel = BaseTrust"
            Case TrustLevel.FullTrust
                Debug.Print "TrustLevel = FullTrust"
            Case TrustLevel.PartialTrust
                Debug.Print "TrustLevel = PartialTrust"
            Case Else
                Debug.Print "TrustLevel = UnknownTrust"
        End Select
        Dim tIIDs() As GUID
        Dim lngIIDsCount As Long
        lngIIDsCount = GetInspectable_GetIIDs(pInspectableInterface, tIIDs)
        Debug.Print "AviableIIDsCount = " & CStr(lngIIDsCount)
        If lngIIDsCount > 0 Then
            Dim lngIIDsItem As Long
            For lngIIDsItem = 0 To lngIIDsCount - 1
                Debug.Print "    AviableIID " & CStr(lngIIDsItem + 1) & _
                            " = " & Guid2Str(tIIDs(lngIIDsItem))
            Next
        End If
        Debug.Print String(60, "-")
    End If
End Sub

Private Function GetInspectable_GetIIDs(ByVal pInterface As Long, _
                                        ByRef tIIDs() As GUID) As Long
    Dim lngIIDCount As Long
    If pInterface <> 0& Then
        Dim pIIDs As Long
        If Invoke(pInterface, IInspectable_GetIids, _
                  VarPtr(lngIIDCount), VarPtr(pIIDs)) = S_OK Then
            If lngIIDCount > 0 Then
                Dim lngBytes As Long
                Dim lngIIDItem As Long
                ReDim tIIDs(lngIIDCount - 1)
                For lngIIDItem = 0 To lngIIDCount - 1
                    lngBytes = Len(tIIDs(lngIIDItem))
                    Call CopyMemory(tIIDs(lngIIDItem), _
                                    ByVal pIIDs + (lngBytes * lngIIDItem), _
                                    lngBytes)
                Next
            End If
        End If
    End If
    GetInspectable_GetIIDs = lngIIDCount
End Function

Private Function GetInspectable_GetRuntimeClassName(ByVal pInterface As Long) As String
    Dim strRet As String
    If pInterface <> 0& Then
        Dim hString As Long
        If Invoke(pInterface, IInspectable_GetRuntimeClassName, _
                  VarPtr(hString)) = S_OK Then
            strRet = Ptr2Str(WindowsGetStringRawBuffer(hString, 0))
            Call WindowsDeleteString(hString)
        End If
    End If
    GetInspectable_GetRuntimeClassName = strRet
End Function

Private Function GetInspectable_GetTrustLevel(ByVal pInterface As Long) As TrustLevel
    Dim eRet As TrustLevel
    If pInterface <> 0& Then
        Dim lngValue As Long
        If Invoke(pInterface, IInspectable_GetTrustLevel, _
                  VarPtr(lngValue)) = S_OK Then
            eRet = lngValue
        End If
    End If
    GetInspectable_GetTrustLevel = eRet
End Function

Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

Private Function OleInvoke(ByVal pInterface As Long, _
                           ByVal lngCmd As Long, _
                           ParamArray aParam()) As Variant
    If pInterface <> 0& Then
        If UBound(aParam) >= 0& Then
            Dim varParam As Variant
            varParam = aParam
            If IsArray(varParam) Then varParam = varParam(0)
            Dim lngCount As Long
            lngCount = UBound(varParam)
            Dim lngItem As Long
            Dim olePtr(10) As Long
            Dim oleTyp(10) As Integer
            For lngItem = 0& To lngCount
                oleTyp(lngItem) = VarType(varParam(lngItem))
                olePtr(lngItem) = VarPtr(varParam(lngItem))
            Next
        End If
        Dim varRet As Variant
        If DispCallFunc(pInterface, lngCmd * 4, CC_STDCALL, _
                        vbLong, lngItem, VarPtr(oleTyp(0)), _
                        VarPtr(olePtr(0)), varRet) <> S_OK Then
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"
        End If

'        If varRet <> S_OK Then
'            Debug.Print "0x" & Hex$(varRet)
'        End If
    End If
    OleInvoke = varRet
End Function

Private Function Str2Guid(ByVal strGUID As String) As GUID
    Call CLSIDFromString(StrPtr(strGUID), Str2Guid)
End Function

Private Function Guid2Str(ByRef tGUID As GUID) As String
    Dim lngRet As Long
    Dim strGUID As String
    strGUID = String(40, 0)
    lngRet = StringFromGUID(tGUID, StrPtr(strGUID), Len(strGUID))
    If lngRet > 0 Then
        strGUID = Left$(strGUID, lngRet - 1)
    Else
        strGUID = vbNullString
    End If
    Guid2Str = strGUID
End Function

Private Function Ptr2Str(ByVal lpStr As Long) As String
    Dim lngLen As Long
    Dim bytBuffer() As Byte
    lngLen = lstrlenW(lpStr) * 2
    If lngLen > 0 Then
        ReDim bytBuffer(lngLen - 1)
        Call CopyMemory(bytBuffer(0), ByVal lpStr, lngLen)
        Call CoTaskMemFree(lpStr)
        Ptr2Str = bytBuffer
    End If
End Function

