VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGSMTCSPI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 12/2022

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const CC_STDCALL As Long = &H4&

Private Const IID_IGlobalSystemMediaTransportControlsSessionPlaybackInfo As String = "{94b4b6cf-e8ba-51ad-87a7-c10ade106127}"

Private Const IID_IClosable As String = "{30d5a829-7fa4-4026-83bb-d75bae4ea99e}"
Private Const IID_IAsyncInfo As String = "{00000036-0000-0000-c000-000000000046}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IUnknown
    IUnknown_QueryInterface = 0
    IUnknown_Release = 2

    ' IInspectable
    IInspectable_GetIids = 3
    IInspectable_GetRuntimeClassName = 4
    IInspectable_GetTrustLevel = 5
    
    ' IAsyncInfo
    IAsyncInfo_GetStatus = 7
    IAsyncInfo_Close = 10

    ' IAsyncInterface
    IAsyncInterface_GetResults = 8
    
    ' IClosable
    IClosable_Close = 6
                        
    ' IGlobalSystemMediaTransportControlsSessionPlaybackInfo
    IGlobalSystemMediaTransportControlsSessionPlaybackInfo_GetControls = 6
    IGlobalSystemMediaTransportControlsSessionPlaybackInfo_GetPlaybackStatus = 7
    IGlobalSystemMediaTransportControlsSessionPlaybackInfo_GetPlaybackType = 8
    IGlobalSystemMediaTransportControlsSessionPlaybackInfo_GetAutoRepeatMode = 9
    IGlobalSystemMediaTransportControlsSessionPlaybackInfo_GetPlaybackRate = 10
    IGlobalSystemMediaTransportControlsSessionPlaybackInfo_GetIsShuffleActive = 11
                        
    ' IReference_MediaPlaybackType
    IReference_MediaPlaybackType_GetValue = 6
                        
    ' IReference_MediaPlaybackAutoRepeatMode
    IReference_MediaPlaybackAutoRepeatMode_GetValue = 6
                        
    ' IReference_Double
    IReference_Double_GetValue = 6
                        
    ' IReference_Boolean
    IReference_Boolean_GetValue = 6
                        
End Enum

Private Enum AsyncStatus
    Started = 0
    Completed = 1
    Canceled = 2
    Error = 3
End Enum

Private Enum TrustLevel
    BaseTrust = 0
    PartialTrust = 1
    FullTrust = 2
End Enum

'Public Enum MediaPlaybackType
'    MediaPlaybackType_Unknown = 0
'    MediaPlaybackType_Music = 1
'    MediaPlaybackType_Video = 2
'    MediaPlaybackType_Image = 3
'End Enum
            
'Public Enum MediaPlaybackAutoRepeatMode
'    MediaPlaybackAutoRepeatMode_None = 0
'    MediaPlaybackAutoRepeatMode_Track = 1
'    MediaPlaybackAutoRepeatMode_List = 2
'End Enum
            
Public Enum GlobalSystemMediaTransportControlsSessionPlaybackStatus
    GlobalSystemMediaTransportControlsSessionPlaybackStatus_Closed = 0
    GlobalSystemMediaTransportControlsSessionPlaybackStatus_Opened = 1
    GlobalSystemMediaTransportControlsSessionPlaybackStatus_Changing = 2
    GlobalSystemMediaTransportControlsSessionPlaybackStatus_Stopped = 3
    GlobalSystemMediaTransportControlsSessionPlaybackStatus_Playing = 4
    GlobalSystemMediaTransportControlsSessionPlaybackStatus_Paused = 5
End Enum

' ----==== Types ====----
Private Type GUID
    data1 As Long
    data2 As Long
    data3 As Long
    data4 As Long
End Type

' ----==== Ole32.dll Declarations ====----
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long
                         
Private Declare Function StringFromGUID Lib "Ole32.dll" _
                         Alias "StringFromGUID2" ( _
                         ByRef rguid As GUID, _
                         ByVal lpsz As Long, _
                         ByVal cchMax As Long) As Long
                         
Private Declare Sub CoTaskMemFree Lib "Ole32.dll" ( _
                    ByVal hMem As Long)
                         
' ----==== Oleaut32.dll Declarations ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long

' ----==== Kernel32.dll Declarations ====----
Private Declare Sub CopyMemory Lib "Kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pTo As Any, _
                    ByRef uFrom As Any, _
                    ByVal lSize As Long)

Private Declare Function lstrlenW Lib "Kernel32.dll" ( _
                         ByVal lpString As Long) As Long

' ----==== Combase.dll Declarations ====----
Private Declare Function WindowsCreateString Lib "Combase.dll" ( _
                         ByVal sourceString As Long, _
                         ByVal lenght As Long, _
                         ByRef hString As Long) As Long

Private Declare Function WindowsGetStringRawBuffer Lib "Combase.dll" ( _
                         ByVal sourceString As Long, _
                         ByRef length As Long) As Long

Private Declare Function WindowsDeleteString Lib "Combase.dll" ( _
                         ByVal sourceString As Long) As Long

Private Declare Function RoGetActivationFactory Lib "Combase.dll" ( _
                         ByVal activatableClassId As Long, _
                         ByRef riid As GUID, _
                         ByRef factory As Long) As Long

Private Declare Function RoActivateInstance Lib "Combase.dll" ( _
                         ByVal activatableClassId As Long, _
                         ByRef instance As Long) As Long

' ----==== Variablen ====----
Private m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call Release(m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo)
End Sub

' ----==== Properties ====----
Public Property Get IGlobalSystemMediaTransportControlsSessionPlaybackInfo() As Long
    IGlobalSystemMediaTransportControlsSessionPlaybackInfo = m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo
End Property

Public Property Let IGlobalSystemMediaTransportControlsSessionPlaybackInfo(ByVal pIGlobalSystemMediaTransportControlsSessionPlaybackInfo As Long)
    Call Release(m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo)
    m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo = pIGlobalSystemMediaTransportControlsSessionPlaybackInfo
End Property

Public Property Get GetControls() As clsGSMTCSPC
    Dim Ret As clsGSMTCSPC
    If m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo <> 0& Then
        Dim pIGlobalSystemMediaTransportControlsSessionPlaybackControls As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo, _
                  IGlobalSystemMediaTransportControlsSessionPlaybackInfo_GetControls, _
                  VarPtr(pIGlobalSystemMediaTransportControlsSessionPlaybackControls)) = S_OK Then
            Set Ret = New clsGSMTCSPC
            Ret.IGlobalSystemMediaTransportControlsSessionPlaybackControls = pIGlobalSystemMediaTransportControlsSessionPlaybackControls
        End If
    End If
    Set GetControls = Ret
End Property

Public Property Get GetPlaybackStatus() As GlobalSystemMediaTransportControlsSessionPlaybackStatus
    Dim Ret As GlobalSystemMediaTransportControlsSessionPlaybackStatus
    If m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo <> 0& Then
        Dim Value As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo, _
                  IGlobalSystemMediaTransportControlsSessionPlaybackInfo_GetPlaybackStatus, _
                  VarPtr(Value)) = S_OK Then
            Ret = Value
        End If
    End If
    GetPlaybackStatus = Ret
End Property

Public Property Get GetPlaybackStatusAsString() As String
    Dim Ret As String
    Select Case Me.GetPlaybackStatus
    Case GlobalSystemMediaTransportControlsSessionPlaybackStatus.GlobalSystemMediaTransportControlsSessionPlaybackStatus_Closed
        Ret = "Closed"
    Case GlobalSystemMediaTransportControlsSessionPlaybackStatus.GlobalSystemMediaTransportControlsSessionPlaybackStatus_Opened
        Ret = "Opened"
    Case GlobalSystemMediaTransportControlsSessionPlaybackStatus.GlobalSystemMediaTransportControlsSessionPlaybackStatus_Changing
        Ret = "Changing"
    Case GlobalSystemMediaTransportControlsSessionPlaybackStatus.GlobalSystemMediaTransportControlsSessionPlaybackStatus_Stopped
        Ret = "Stopped"
    Case GlobalSystemMediaTransportControlsSessionPlaybackStatus.GlobalSystemMediaTransportControlsSessionPlaybackStatus_Playing
        Ret = "Playing"
    Case GlobalSystemMediaTransportControlsSessionPlaybackStatus.GlobalSystemMediaTransportControlsSessionPlaybackStatus_Paused
        Ret = "Paused"
    End Select
    GetPlaybackStatusAsString = Ret
End Property

Public Property Get GetPlaybackType() As MediaPlaybackType
    Dim Ret As MediaPlaybackType
    If m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo <> 0& Then
        Dim pIReference_MediaPlaybackType As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo, _
                  IGlobalSystemMediaTransportControlsSessionPlaybackInfo_GetPlaybackType, _
                  VarPtr(pIReference_MediaPlaybackType)) = S_OK Then
            Dim Value As Long
            If Invoke(pIReference_MediaPlaybackType, _
                      IReference_MediaPlaybackType_GetValue, _
                      VarPtr(Value)) = S_OK Then
                Ret = Value
            End If
            Call Release(pIReference_MediaPlaybackType)
        End If
    End If
    GetPlaybackType = Ret
End Property

Public Property Get GetPlaybackTypeAsString() As String
    Dim Ret As String
    Select Case Me.GetPlaybackType
    Case MediaPlaybackType.MediaPlaybackType_Unknown
        Ret = "Unknown"
    Case MediaPlaybackType.MediaPlaybackType_Music
        Ret = "Music"
    Case MediaPlaybackType.MediaPlaybackType_Video
        Ret = "Video"
    Case MediaPlaybackType.MediaPlaybackType_Image
        Ret = "Image"
    End Select
    GetPlaybackTypeAsString = Ret
End Property

Public Property Get GetAutoRepeatMode() As MediaPlaybackAutoRepeatMode
    Dim Ret As MediaPlaybackAutoRepeatMode
    If m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo <> 0& Then
        Dim pIReference_MediaPlaybackAutoRepeatMode As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo, _
                  IGlobalSystemMediaTransportControlsSessionPlaybackInfo_GetAutoRepeatMode, _
                  VarPtr(pIReference_MediaPlaybackAutoRepeatMode)) = S_OK Then
            Dim Value As Long
            If Invoke(pIReference_MediaPlaybackAutoRepeatMode, _
                      IReference_MediaPlaybackAutoRepeatMode_GetValue, _
                      VarPtr(Value)) = S_OK Then
                Ret = Value
            End If
            Call Release(pIReference_MediaPlaybackAutoRepeatMode)
        End If
    End If
    GetAutoRepeatMode = Ret
End Property

Public Property Get GetAutoRepeatModeAsString() As String
    Dim Ret As String
    Select Case Me.GetAutoRepeatMode
    Case MediaPlaybackAutoRepeatMode.MediaPlaybackAutoRepeatMode_None
        Ret = "None"
    Case MediaPlaybackAutoRepeatMode.MediaPlaybackAutoRepeatMode_Track
        Ret = "Track"
    Case MediaPlaybackAutoRepeatMode.MediaPlaybackAutoRepeatMode_List
        Ret = "List"
    End Select
    GetAutoRepeatModeAsString = Ret
End Property

Public Property Get GetPlaybackRate() As Double
    Dim Ret As Double
    If m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo <> 0& Then
        Dim pIReference_Double As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo, _
                  IGlobalSystemMediaTransportControlsSessionPlaybackInfo_GetPlaybackRate, _
                  VarPtr(pIReference_Double)) = S_OK Then
            Dim Value As Double
            If Invoke(pIReference_Double, _
                      IReference_Double_GetValue, _
                      VarPtr(Value)) = S_OK Then
                Ret = Value
            End If
            Call Release(pIReference_Double)
        End If
    End If
    GetPlaybackRate = Ret
End Property

Public Property Get GetIsShuffleActive() As Boolean
    Dim Ret As Boolean
    If m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo <> 0& Then
        Dim pIReference_Boolean As Long
        If Invoke(m_pIGlobalSystemMediaTransportControlsSessionPlaybackInfo, _
                  IGlobalSystemMediaTransportControlsSessionPlaybackInfo_GetIsShuffleActive, _
                  VarPtr(pIReference_Boolean)) = S_OK Then
            Dim Value As Boolean
            If Invoke(pIReference_Boolean, _
                      IReference_Boolean_GetValue, _
                      VarPtr(Value)) = S_OK Then
                Ret = Value
            End If
            Call Release(pIReference_Boolean)
        End If
    End If
    GetIsShuffleActive = Ret
End Property

' ----==== Subs & Functions ====----
Private Function GetActivationFactory(ByVal ClassName As String, _
                                      ByVal IID As String, _
                                      ByRef pFactory As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    Dim hString As Long
    If WindowsCreateString(StrPtr(ClassName), Len(ClassName), hString) = S_OK Then
        If hString <> 0& Then
            If RoGetActivationFactory(hString, Str2Guid(IID), pFactory) = S_OK Then bolRet = True
            Call WindowsDeleteString(hString)
        End If
    End If
    GetActivationFactory = bolRet
End Function

Private Function GetActivateInstance(ByVal ClassName As String, _
                                     ByVal IID As String, _
                                     ByRef pInstance As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    Dim hString As Long
    If WindowsCreateString(StrPtr(ClassName), Len(ClassName), hString) = S_OK Then
        If hString <> 0& Then
            Dim pIInspectable As Long
            If RoActivateInstance(hString, pIInspectable) = S_OK Then
                If pIInspectable <> 0& Then
                    If Invoke(pIInspectable, IUnknown_QueryInterface, _
                              VarPtr(Str2Guid(IID)), VarPtr(pInstance)) = S_OK Then
                        If pInstance <> 0& Then bolRet = True
                    End If
                    Call Release(pIInspectable)
                End If
            End If
            Call WindowsDeleteString(hString)
        End If
    End If
    GetActivateInstance = bolRet
End Function

Private Function WaitForAsync(ByRef pInterface As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    If pInterface <> 0& Then
        Dim pIAsyncInfo As Long
        If Invoke(pInterface, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_IAsyncInfo)), _
                  VarPtr(pIAsyncInfo)) = S_OK Then
            Dim eStatus As AsyncStatus
            Do
                If Invoke(pIAsyncInfo, IAsyncInfo_GetStatus, _
                          VarPtr(eStatus)) = S_OK Then DoEvents
            Loop While eStatus = Started
            If eStatus = Completed Then
                bolRet = True
            Else
                Call Invoke(pIAsyncInfo, IAsyncInfo_Close)
            End If
            Call Release(pIAsyncInfo)
            If bolRet Then
                Dim pRet As Long
                If Invoke(pInterface, IAsyncInterface_GetResults, VarPtr(pRet)) = S_OK Then
                    Call Release(pInterface)
                    pInterface = pRet
                End If
            Else
                Call Release(pInterface)
            End If
        End If
    End If
    WaitForAsync = bolRet
End Function

Private Sub Release(ByRef pInterface As Long)
    Dim lngRet As Long
    If pInterface <> 0& Then
        Call Invoke(pInterface, IUnknown_Release)
        pInterface = 0&
    End If
End Sub

Private Function CloseAndRelease(ByRef pInterface As Long) As Long
    Dim lngRet As Long
    If pInterface <> 0& Then
        Dim pIClosable As Long
        If Invoke(pInterface, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_IClosable)), _
                  VarPtr(pIClosable)) = S_OK Then
            Call Invoke(pIClosable, IClosable_Close)
            Call Release(pIClosable)
            Call Release(pInterface)
            pInterface = 0&
        End If
    End If
    CloseAndRelease = lngRet
End Function

Private Sub GetInspectableInfo(ByVal pInspectableInterface As Long, _
                               ByVal strInterface As String)
    If pInspectableInterface <> 0& Then
        Debug.Print "Inspectable Info for: " & strInterface
        Debug.Print "RuntimeClassName = " & GetInspectable_GetRuntimeClassName(pInspectableInterface)
        Dim eTrustLevel As TrustLevel
        eTrustLevel = GetInspectable_GetTrustLevel(pInspectableInterface)
        Select Case eTrustLevel
            Case TrustLevel.BaseTrust
                Debug.Print "TrustLevel = BaseTrust"
            Case TrustLevel.FullTrust
                Debug.Print "TrustLevel = FullTrust"
            Case TrustLevel.PartialTrust
                Debug.Print "TrustLevel = PartialTrust"
            Case Else
                Debug.Print "TrustLevel = UnknownTrust"
        End Select
        Dim tIIDs() As GUID
        Dim lngIIDsCount As Long
        lngIIDsCount = GetInspectable_GetIIDs(pInspectableInterface, tIIDs)
        Debug.Print "AviableIIDsCount = " & CStr(lngIIDsCount)
        If lngIIDsCount > 0 Then
            Dim lngIIDsItem As Long
            For lngIIDsItem = 0 To lngIIDsCount - 1
                Debug.Print "    AviableIID " & CStr(lngIIDsItem + 1) & _
                            " = " & Guid2Str(tIIDs(lngIIDsItem))
            Next
        End If
        Debug.Print String(60, "-")
    End If
End Sub

Private Function GetInspectable_GetIIDs(ByVal pInterface As Long, _
                                        ByRef tIIDs() As GUID) As Long
    Dim lngIIDCount As Long
    If pInterface <> 0& Then
        Dim pIIDs As Long
        If Invoke(pInterface, IInspectable_GetIids, _
                  VarPtr(lngIIDCount), VarPtr(pIIDs)) = S_OK Then
            If lngIIDCount > 0 Then
                Dim lngBytes As Long
                Dim lngIIDItem As Long
                ReDim tIIDs(lngIIDCount - 1)
                For lngIIDItem = 0 To lngIIDCount - 1
                    lngBytes = Len(tIIDs(lngIIDItem))
                    Call CopyMemory(tIIDs(lngIIDItem), _
                                    ByVal pIIDs + (lngBytes * lngIIDItem), _
                                    lngBytes)
                Next
            End If
        End If
    End If
    GetInspectable_GetIIDs = lngIIDCount
End Function

Private Function GetInspectable_GetRuntimeClassName(ByVal pInterface As Long) As String
    Dim strRet As String
    If pInterface <> 0& Then
        Dim hString As Long
        If Invoke(pInterface, IInspectable_GetRuntimeClassName, _
                  VarPtr(hString)) = S_OK Then
            strRet = Ptr2Str(WindowsGetStringRawBuffer(hString, 0))
            Call WindowsDeleteString(hString)
        End If
    End If
    GetInspectable_GetRuntimeClassName = strRet
End Function

Private Function GetInspectable_GetTrustLevel(ByVal pInterface As Long) As TrustLevel
    Dim eRet As TrustLevel
    If pInterface <> 0& Then
        Dim lngValue As Long
        If Invoke(pInterface, IInspectable_GetTrustLevel, _
                  VarPtr(lngValue)) = S_OK Then
            eRet = lngValue
        End If
    End If
    GetInspectable_GetTrustLevel = eRet
End Function

Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

Private Function OleInvoke(ByVal pInterface As Long, _
                           ByVal lngCmd As Long, _
                           ParamArray aParam()) As Variant
    If pInterface <> 0& Then
        If UBound(aParam) >= 0& Then
            Dim varParam As Variant
            varParam = aParam
            If IsArray(varParam) Then varParam = varParam(0)
            Dim lngCount As Long
            lngCount = UBound(varParam)
            Dim lngItem As Long
            Dim olePtr(10) As Long
            Dim oleTyp(10) As Integer
            For lngItem = 0& To lngCount
                oleTyp(lngItem) = VarType(varParam(lngItem))
                olePtr(lngItem) = VarPtr(varParam(lngItem))
            Next
        End If
        Dim varRet As Variant
        If DispCallFunc(pInterface, lngCmd * 4, CC_STDCALL, _
                        vbLong, lngItem, VarPtr(oleTyp(0)), _
                        VarPtr(olePtr(0)), varRet) <> S_OK Then
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"
        End If

'        If varRet <> S_OK Then
'            Debug.Print "0x" & Hex$(varRet)
'        End If
    End If
    OleInvoke = varRet
End Function

Private Function Str2Guid(ByVal strGUID As String) As GUID
    Call CLSIDFromString(StrPtr(strGUID), Str2Guid)
End Function

Private Function Guid2Str(ByRef tGUID As GUID) As String
    Dim lngRet As Long
    Dim strGUID As String
    strGUID = String(40, 0)
    lngRet = StringFromGUID(tGUID, StrPtr(strGUID), Len(strGUID))
    If lngRet > 0 Then
        strGUID = Left$(strGUID, lngRet - 1)
    Else
        strGUID = vbNullString
    End If
    Guid2Str = strGUID
End Function

Private Function Ptr2Str(ByVal lpStr As Long) As String
    Dim lngLen As Long
    Dim bytBuffer() As Byte
    lngLen = lstrlenW(lpStr) * 2
    If lngLen > 0 Then
        ReDim bytBuffer(lngLen - 1)
        Call CopyMemory(bytBuffer(0), ByVal lpStr, lngLen)
        Call CoTaskMemFree(lpStr)
        Ptr2Str = bytBuffer
    End If
End Function

